var oResult = new Object();

function init(request) {
    var oSession = AccessSecurityManager.getSessionInfo();
    var loginGroupId = oSession.loginGroup;
    oResult.loginGroupId = Procedure.imw_utils.escapeHTML(loginGroupId);
    oResult.result = Procedure.imw_utils.escapeHTML(request.result);
    if (isBlank(oResult.result)) oResult.result = "Push REPAIR button.";
}

function repair(request) {
    var oSession = AccessSecurityManager.getSessionInfo();
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var manager = new FlowGroupManager(loginGroupId);
    var result = new Array();
    var records = new Array();
    var recordh = new Object();

    result.push("---- start ----");
    do {
        if (!makeFlowGroupTree(manager, result, records, recordh, localeId)) {
            result.push("[ERROR] makeFlowGroupTree is failed.");
            break;
        }
        result.push("");
        if (!deleteFlowGroupInc(manager, result)) {
            result.push("[ERROR] deleteFlowGroupInc is failed.");
            break;
        }
        result.push("");
        if (!createFlowGroupInc(manager, result, records, recordh)) {
            result.push("[ERROR] createFlowGroupInc is failed.");
            break;
        }
        result.push("");
        result.push("REPAIR SUCCESSED.");
    } while (false);
    result.push("---- end ----");

    var oReqParam = new Object();
    oReqParam.result = result.join("\r\n");
    forward("flowgroup_repair", oReqParam);
}

function makeFlowGroupTree(manager, result, records, recordh, localeId) {
    result.push("making flow group tree.");

    var params = new Array();
    params.push(new DbParameter(localeId, DbParameter.TYPE_STRING));
    var ret = DatabaseManager.select("select group_id, group_name, group_full_path, absolute_depth_level from imw_m_group where locale_id=? order by group_full_path", params);
    if (ret.error) {
        result.push("[ERROR] SQL is failed.");
        return false;
    }

    result.push(ret.data.length + " records found.");
    var i, j, record, cnt;
    for (i = 0; i < ret.data.length; i++) {
        record = new Object();
        record.flowGroupId = ret.data[i].group_id;
        record.name = ret.data[i].group_name;
        record.fullPath = ret.data[i].group_full_path;
        record.absoluteLevel = ret.data[i].absolute_depth_level - 0;
        records.push(record);
        recordh[record.fullPath] = record;

        for (j = cnt = 0; j < record.fullPath.length; j++) {
            if (record.fullPath.charAt(j) == "/") cnt++;
        }
        if (cnt != record.absoluteLevel) {
            result.push("[ERROR] absoluteDepthLevel is invalid. " + record.flowGroupId + " : " + cnt + " != " + record.absoluteLevel);
        }
    }

    result.push("done.");
    return true;
}

function deleteFlowGroupInc(manager, result) {
    result.push("deleting records of imw_m_group_inc table.");

    var ret = DatabaseManager.select("delete from imw_m_group_inc");
    if (ret.error) {
        result.push("[ERROR] SQL is failed.");
        return false;
    }

    result.push("done.");
    return true;
}

function createFlowGroupInc(manager, result, records, recordh) {
    result.push("repairing records of imw_m_group_inc table.");

    var ret;
    var i, j, record, inc, parentPath, flowGroupId, absoluteLevel;
    for (i = 0; i < records.length; i++) {
        record = records[i];
        flowGroupId = record.flowGroupId;
        absoluteLevel = record.absoluteLevel;

        inc = new Object();
        inc.flowGroupId = flowGroupId;
        inc.parentFlowGroupId = flowGroupId;
        inc.depthLevel = "0";
        ret = manager.createFlowGroupInc(inc);
        if (!ret.resultFlag) {
            result.push("[ERROR] createFlowGroupInc is failed.");
            continue;
        }

        for (j = 1; j < absoluteLevel; j++) {
            parentPath = record.fullPath.substring(0, record.fullPath.length - record.name.length - 1);
            record = recordh[parentPath];
            if (!record) {
                result.push("[ERROR] parent flow group is not found. " + parentPath);
                break;
            }

            inc = new Object();
            inc.flowGroupId = flowGroupId;
            inc.parentFlowGroupId = record.flowGroupId;
            inc.depthLevel = j + "";
            ret = manager.createFlowGroupInc(inc);
            if (!ret.resultFlag) {
                result.push("[ERROR] createFlowGroupInc is failed.");
                break;
            }
        }
    }

    result.push("done.");
    return true;
}
